require 'net/ftp'

class Net::FTP
	
	def directory?(name)
		regexp = /#{name}$/
		line = ls.find { |line| line =~ regexp }
		line or false and line[0] == ?d
	end
	
	def entries
		nlst.reject { |e| e =~ /^(\.|\.\.)$/ }
	end
	
	alias _chdir chdir
	def chdir(dir)
		wd = (dir =~ /^\.?$/)
		if block_given?
			current = pwd
			wd or _chdir dir
			begin
				yield
			ensure
				wd or _chdir current
			end
		else
			wd or _chdir dir
		end
	end
	
	def put_contents(dir)
		Dir[dir+'/*'].each &method(:put_r)
	end
	
	def put_r(file)
		filename = File.basename file
		if File.directory? file
			mkdir filename
			chdir(filename) { put_contents file }
		else
			put file, filename
		end
	end
	
	def rm_contents(dir)
		chdir(dir) {
			entries.each &method(:rm_r)
		}
	end
	
	def rm_r(file)
		if directory? file
			rm_contents file
			rmdir file
		else
			delete file
		end
	end
	
end