require 'rake'
require 'rake/tasklib'
require 'highline'
require 'tmpdir'

require 'razor'
require 'razor/rake/ftp'

module Razor
	
	module Rake
		
		module FTP
			
			class Push < ::Rake::TaskLib
				
				attr_accessor :port
				attr_accessor :dir
				attr_accessor :url_base
				
				def initialize(hostname, name='ftp:push')
					@name = name
					@hostname = hostname
					@dir = ''
					@port = nil
					@url_base = '/'
					yield self if block_given?
					define_task
				end
				
				def define_task
					task(@name) {
						hl = HighLine.new
						host = [@hostname]
						host << @port if @port
						ftp = Net::FTP.new(*host)
						begin
							username = hl.ask("FTP Username : ")
							psswd = hl.ask("Password : ", String) { |q| q.echo = false }
							ftp.login(username, psswd)
							ftp.chdir @dir
							ftp.rm_contents '.'
							Dir.mktmpdir { |tmp|
								Razor.generate(generate_options, '.', tmp)
								ftp.put_contents tmp
							}
						ensure
							ftp.close
						end
					}
				end
				
				def generate_options
					{
						:url_base => @url_base
					}
				end
				
			end
			
		end
		
	end
	
end
