require 'gli'

require 'razor'

include GLI
		
version Razor::Version
	
desc 'Explains what is being done.'
switch [:v, :verbose]
		
desc 'Generates website from source to destination. If destination is not given, site is generated in [source]/_site, current directory is the default source.'
arg_name '[source [destination]]'
command [:generate] do |c|
		
	c.desc 'Sets website url-base.'
	c.arg_name 'URL'
	c.flag [:u, 'url-base']
					
	c.action { |gopts, opts, args|
		args = ['.', '_site'] if args.empty?
		args << File.join(args[0], '_site') if args.size==1
		Razor.generate(opts, *args)
	}
	
end
			
desc 'Runs a WEBrick server which renders site on the fly.'
arg_name '[source]'
command [:server] do |c|
		
	c.desc 'Sets server port.'
	c.arg_name 'PORT'
	c.flag [:p, 'port']
			
	c.action { |gopts, opts, args|
		src = args[0] || '.'
		Razor.server(opts[:port], src)
	}
				
end
		
desc 'Print razor version'
command [:v, :version] do |c|
	c.action { |gopts, opts, args| puts Razor::Version }
end